--[[
If you are mod creator and want to add support of your trap to my mod,
add the following code to the beginning of your modmain.lua:


if not GLOBAL.rawget(GLOBAL,"ALL_TRAPS") then
	GLOBAL.rawset(GLOBAL,"ALL_TRAPS",{})
end
GLOBAL.ALL_TRAPS["your_trap_prefab_name"] =
{
	animal_damage = 60, --this is an example
	pvp_damage = 45,
	uses = 12,
}

--Your trap must have "mine" component.
--]]
_G = GLOBAL
Ingredient = _G.Ingredient
TUNING.TRAP_TEETH_DAMAGE = 45
net_string = _G.net_string
AllRecipes=_G.AllRecipes
RECIPETABS = _G.RECIPETABS
TECH = _G.TECH
p=_G.rawget(_G,"p") or print
_G.Recipe("trap_teeth", {Ingredient("log", 5),Ingredient("rope", 5),Ingredient("houndstooth", 2)}, RECIPETABS.WAR,  TECH.SCIENCE_TWO)

--supported by default:
ALL_TRAPS = {trap_teeth=1,beemine=1,stingertrap=1,speartrap=1,spiketrap=1,spiketrapsmall=1}

--меняем рецепты (если они есть)
if AllRecipes.spiketrapsmall then
	AllRecipes.spiketrapsmall.ingredients = { Ingredient("twigs", 2), Ingredient("stinger", 1), Ingredient("log", 1) }
	AllRecipes.spiketrapsmall.level = TECH.SCIENCE_ONE
end
if AllRecipes.stingertrap then
	AllRecipes.stingertrap.ingredients = { Ingredient("log", 5), Ingredient("rope", 5), Ingredient("stinger", 2)}
	AllRecipes.stingertrap.level = TECH.SCIENCE_ONE
end
if AllRecipes.speartrap then
	AllRecipes.speartrap.ingredients = { Ingredient("spear", 4), Ingredient("rope", 5), Ingredient("turf_woodfloor", 1)}
	AllRecipes.speartrap.level = TECH.SCIENCE_TWO
end
if AllRecipes.spiketrap then
	AllRecipes.spiketrap.ingredients = { Ingredient("turf_forest", 1), Ingredient("twigs", 5), Ingredient("stinger", 4) }
	AllRecipes.spiketrap.level = TECH.SCIENCE_TWO
end



--support of unknown and future traps:
if _G.rawget(_G,"ALL_TRAPS") and type(_G.ALL_TRAPS)=="table" then
	for k,v in pairs(_G.ALL_TRAPS) do
		ALL_TRAPS[k]=v or 1
	end
end

local rebalance_traps = {}

local BALANCE_DAMAGE = GetModConfigData("balance_damage")
if BALANCE_DAMAGE then
	for k,v in pairs(ALL_TRAPS) do
		if type(v)=="table" and v.animal_damage and v.pvp_damage then
			rebalance_traps[k]=v
		end
	end
	if not rebalance_traps.spiketrapsmall then
		rebalance_traps.spiketrapsmall = { pvp_damage = 25, uses = 10 }
		TUNING.SPIKE_TRAP_SMALL_DAMAGE = 25
		TUNING.SPIKE_TRAP_SMALL_USES = 10
	end
	if not rebalance_traps.stingertrap then
		rebalance_traps.stingertrap = { pvp_damage = 35, uses = 12 }
		TUNING.STINGERTRAP_DAMAGE = 35
		TUNING.STINGERTRAP_USES = 12
	end
	if not rebalance_traps.speartrap then
		rebalance_traps.speartrap = { pvp_damage = 35, uses = 10 }
	end
	if not rebalance_traps.spiketrap then
		rebalance_traps.spiketrap = { pvp_damage = 45, uses = 15 }
		TUNING.SPIKE_TRAP_DAMAGE = 45
		TUNING.SPIKE_TRAP_USES = 15
	end
end


--выставляет правильную анимацию, в зависимости от n1,n2,...,n6 и anim_num
local function SetNewAnim(inst)
	local new_val
	if (inst.anim_num == 1) then --transparent
		new_val = 0.1
		local p = _G.ThePlayer
		if p and (inst.n1 == p.userid or inst.n2 == p.userid or inst.n3 == p.userid
			 or inst.n4 == p.userid or inst.n5 == p.userid or inst.n6 == p.userid)
		then
			new_val = 1 --0.75
		end
	else --non-transparent
		new_val = 1
	end
	if new_val ~= inst.transp_value then
		inst.transp_value = new_val
		inst.AnimState:OverrideMultColour(new_val,new_val,new_val,new_val)
		if inst.MiniMapEntity then
			if new_val < 0.5 then --hide
				inst.MiniMapEntity:SetEnabled(false)
			else --show
				inst.MiniMapEntity:SetEnabled(true)
			end
		end
	end
end

local function QueueAnim(inst,anim)
	if inst.inv_task then
		inst.inv_task:Cancel()
	end
	if not anim then --возможен "пустой" вызов
		anim = inst.anim_num or 0
	end
	inst.inv_task = inst:DoTaskInTime(0,function()
		inst.inv_task = nil
		inst.anim_num = anim
		inst.net_anim_num:set(anim)
		SetNewAnim(inst)
	end)
end


-----------------------------------Works only on host.-----------------------------------
if _G.TheNet and _G.TheNet:GetIsServer() then
local pl = _G.AllPlayers


MONITORING_DISTANCE = GetModConfigData("distance") or (20 * 20)
CAN_SEE = (GetModConfigData("time_see") or 2.5) --minutes
--Переводим минуты в тики таймера. В данном случае у нас 10 секунд
TIMER_TICK = 10 --seconds
CAN_SEE = CAN_SEE * (60 / TIMER_TICK) --ticks
CAN_TALK = GetModConfigData("can_talk")

--Срабатывает каждые 11 сек для каждой ловушки.
--В активном режиме (по умолчанию true) прибавляет по единице, иначе сразу всю величину.
local function OnUpdateTrap(inst,active,only_for_player)
	if not inst then return end
	if active == nil then active=true end
	local m = inst.components.mine
	if not m then return end --нет смысла обрабатывать то, чего нет. Ловушка, скорее всего, уничтожена.
	local talkers = {} --прямые указатели на игроков, которые в деле (для произнесения ими "I can see it!")
	for _,v in ipairs(pl) do
		if v.userid and ((not only_for_player) or only_for_player.userid == v.userid) then
			if v.userid~=m.owners[1] and (inst:GetDistanceSqToInst(v) <= MONITORING_DISTANCE) then
				if not m.pret[v.userid] then
					m.pret[v.userid]=0
				end
				local plus = (active and 1 or CAN_SEE)
				if plus >= CAN_SEE and m.pret[v.userid] < CAN_SEE then
					talkers[v.userid] = v
				end
				m.pret[v.userid] = m.pret[v.userid] + plus
				if m.pret[v.userid] >= CAN_SEE then
					local found = 6
					for i=2,6 do
						if m.owners[i] == v.userid then
							found = i
							break
						end
					end
					for i=found,3,-1 do
						m.owners[i] = m.owners[i-1]
					end
					m.owners[2] = v.userid
				end
			end
		end
	end
	for i=1,6 do m.new_data[i]=m.owners[i] end
	table.sort(m.new_data)
	if CAN_TALK and not active then --ловушка устанавливается
		for i=2,6 do
			if m.owners[i]~="" and talkers[m.owners[i]] then
				local t = talkers[m.owners[i]].components.talker
				if t then
					t:Say('I can see it!')
				end
			end
		end
	end
	local b = false
	if m.new_data[1] ~= inst.n1 then inst.n1=m.new_data[1] inst.net_n1:set(inst.n1) b=true end
	if m.new_data[2] ~= inst.n2 then inst.n2=m.new_data[2] inst.net_n2:set(inst.n2) b=true end
	if m.new_data[3] ~= inst.n3 then inst.n3=m.new_data[3] inst.net_n3:set(inst.n3) b=true end
	if m.new_data[4] ~= inst.n4 then inst.n4=m.new_data[4] inst.net_n4:set(inst.n4) b=true end
	if m.new_data[5] ~= inst.n5 then inst.n5=m.new_data[5] inst.net_n5:set(inst.n5) b=true end
	if m.new_data[6] ~= inst.n6 then inst.n6=m.new_data[6] inst.net_n6:set(inst.n6) b=true end
	if b then QueueAnim(inst) end
end




----- Converting back from UTF-8 (russian support)
--[[
--С введение поддержки UTF это потеряло актуальность.
local _utf8={[0x0000] = 0x00,[0x0001] = 0x01,[0x0002] = 0x02,[0x0003] = 0x03,[0x0004] = 0x04,[0x0005] = 0x05,[0x0006] = 0x06,[0x0007] = 0x07,
[0x0008] = 0x08,[0x0009] = 0x09,[0x000A] = 0x0A,[0x000B] = 0x0B,[0x000C] = 0x0C,[0x000D] = 0x0D,[0x000E] = 0x0E,[0x000F] = 0x0F,[0x0010] = 0x10,
[0x0011] = 0x11,[0x0012] = 0x12,[0x0013] = 0x13,[0x0014] = 0x14,[0x0015] = 0x15,[0x0016] = 0x16,[0x0017] = 0x17,[0x0018] = 0x18,[0x0019] = 0x19,
[0x001A] = 0x1A,[0x001B] = 0x1B,[0x001C] = 0x1C,[0x001D] = 0x1D,[0x001E] = 0x1E,[0x001F] = 0x1F,[0x0020] = 0x20,[0x0021] = 0x21,[0x0022] = 0x22,
[0x0023] = 0x23,[0x0024] = 0x24,[0x0025] = 0x25,[0x0026] = 0x26,[0x0027] = 0x27,[0x0028] = 0x28,[0x0029] = 0x29,[0x002A] = 0x2A,[0x002B] = 0x2B,
[0x002C] = 0x2C,[0x002D] = 0x2D,[0x002E] = 0x2E,[0x002F] = 0x2F,[0x0030] = 0x30,[0x0031] = 0x31,[0x0032] = 0x32,[0x0033] = 0x33,[0x0034] = 0x34,
[0x0035] = 0x35,[0x0036] = 0x36,[0x0037] = 0x37,[0x0038] = 0x38,[0x0039] = 0x39,[0x003A] = 0x3A,[0x003B] = 0x3B,[0x003C] = 0x3C,[0x003D] = 0x3D,
[0x003E] = 0x3E,[0x003F] = 0x3F,[0x0040] = 0x40,[0x0041] = 0x41,[0x0042] = 0x42,[0x0043] = 0x43,[0x0044] = 0x44,[0x0045] = 0x45,[0x0046] = 0x46,
[0x0047] = 0x47,[0x0048] = 0x48,[0x0049] = 0x49,[0x004A] = 0x4A,[0x004B] = 0x4B,[0x004C] = 0x4C,[0x004D] = 0x4D,[0x004E] = 0x4E,[0x004F] = 0x4F,
[0x0050] = 0x50,[0x0051] = 0x51,[0x0052] = 0x52,[0x0053] = 0x53,[0x0054] = 0x54,[0x0055] = 0x55,[0x0056] = 0x56,[0x0057] = 0x57,[0x0058] = 0x58,
[0x0059] = 0x59,[0x005A] = 0x5A,[0x005B] = 0x5B,[0x005C] = 0x5C,[0x005D] = 0x5D,[0x005E] = 0x5E,[0x005F] = 0x5F,[0x0060] = 0x60,[0x0061] = 0x61,
[0x0062] = 0x62,[0x0063] = 0x63,[0x0064] = 0x64,[0x0065] = 0x65,[0x0066] = 0x66,[0x0067] = 0x67,[0x0068] = 0x68,[0x0069] = 0x69,[0x006A] = 0x6A,
[0x006B] = 0x6B,[0x006C] = 0x6C,[0x006D] = 0x6D,[0x006E] = 0x6E,[0x006F] = 0x6F,[0x0070] = 0x70,[0x0071] = 0x71,[0x0072] = 0x72,[0x0073] = 0x73,
[0x0074] = 0x74,[0x0075] = 0x75,[0x0076] = 0x76,[0x0077] = 0x77,[0x0078] = 0x78,[0x0079] = 0x79,[0x007A] = 0x7A,[0x007B] = 0x7B,[0x007C] = 0x7C,
[0x007D] = 0x7D,[0x007E] = 0x7E,[0x007F] = 0x7F,[0x0402] = 0x80,[0x0403] = 0x81,[0x201A] = 0x82,[0x0453] = 0x83,[0x201E] = 0x84,[0x2026] = 0x85,
[0x2020] = 0x86,[0x2021] = 0x87,[0x20AC] = 0x88,[0x2030] = 0x89,[0x0409] = 0x8A,[0x2039] = 0x8B,[0x040A] = 0x8C,[0x040C] = 0x8D,[0x040B] = 0x8E,
[0x040F] = 0x8F,[0x0452] = 0x90,[0x2018] = 0x91,[0x2019] = 0x92,[0x201C] = 0x93,[0x201D] = 0x94,[0x2022] = 0x95,[0x2013] = 0x96,[0x2014] = 0x97,
[0x2122] = 0x99,[0x0459] = 0x9A,[0x203A] = 0x9B,[0x045A] = 0x9C,[0x045C] = 0x9D,[0x045B] = 0x9E,[0x045F] = 0x9F,[0x00A0] = 0xA0,[0x040E] = 0xA1,
[0x045E] = 0xA2,[0x0408] = 0xA3,[0x00A4] = 0xA4,[0x0490] = 0xA5,[0x00A6] = 0xA6,[0x00A7] = 0xA7,[0x0401] = 'Yo',[0x00A9] = 0xA9,[0x0404] = 0xAA,
[0x00AB] = 0xAB,[0x00AC] = 0xAC,[0x00AD] = 0xAD,[0x00AE] = 0xAE,[0x0407] = 0xAF,[0x00B0] = 0xB0,[0x00B1] = 0xB1,[0x0406] = 0xB2,[0x0456] = 0xB3,
[0x0491] = 0xB4,[0x00B5] = 0xB5,[0x00B6] = 0xB6,[0x00B7] = 0xB7,[0x0451] = 'yo',[0x2116] = 0xB9,[0x0454] = 0xBA,[0x00BB] = 0xBB,[0x0458] = 0xBC,
[0x0405] = 0xBD,[0x0455] = 0xBE,[0x0457] = 0xBF,[0x0410] = 'A',[0x0411] = 'B',[0x0412] = 'V',[0x0413] = 'G',[0x0414] = 'D',[0x0415] = 'E',
[0x0416] = 'J',[0x0417] = 'Z',[0x0418] = 'I',[0x0419] = 'J',[0x041A] = 'K',[0x041B] = 'L',[0x041C] = 'M',[0x041D] = 'N',[0x041E] = 'O',
[0x041F] = 'P',[0x0420] = 'R',[0x0421] = 'S',[0x0422] = 'T',[0x0423] = 'Y',[0x0424] = 'F',[0x0425] = 'H',[0x0426] = 'C',[0x0427] = 'Ch',
[0x0428] = 'Sh',[0x0429] = 'Sch',[0x042A] = "'",[0x042B] = 'Y',[0x042C] = "'",[0x042D] = 'E',[0x042E] = 'Yu',[0x042F] = 'Ya',[0x0430] = 'a',
[0x0431] = 'b',[0x0432] = 'v',[0x0433] = 'g',[0x0434] = 'd',[0x0435] = 'e',[0x0436] = 'j',[0x0437] = 'z',[0x0438] = 'i',[0x0439] = 'j',
[0x043A] = 'k',[0x043B] = 'l',[0x043C] = 'm',[0x043D] = 'n',[0x043E] = 'o',[0x043F] = 'p',[0x0440] = 'r',[0x0441] = 's',[0x0442] = 't',
[0x0443] = 'y',[0x0444] = 'f',[0x0445] = 'h',[0x0446] = 'c',[0x0447] = 'ch',[0x0448] = 'sh',[0x0449] = 'sch',[0x044A] = "'",[0x044B] = "y",
[0x044C] = "'",[0x044D] = 'e',[0x044E] = 'yu',[0x044F] = 'ya'}
local function convertfromutf8(str)
	if not str or type(str)~="string" then return str end
	local str2=""
	for uchar in string.gfind(str, "([%z\1-\127\194-\244][\128-\191]*)") do
       		if #uchar==1 then
			str2=str2..uchar
		elseif #uchar==2 then
			local res=(uchar:byte(1)-0xC0)*0x40+uchar:byte(2)-0x80
			if _utf8[res] then
				if type(_utf8[res])=="string" then
					str2=str2.._utf8[res]
				else
					str2=str2..string.char(_utf8[res])
				end
			end
		end
	end
	return str2
end
--]]



--- Mine component
local mine = _G.require "components/mine"
local old_reset = mine.Reset
function mine:Reset()
	--p("Reset")
	local m = self
	m.inst:DoTaskInTime(0,function() --hack that prevents damage on deploy
	--[[
	if not m.was_loaded then
		m.owners = {"","","","","",""}
		print("RESET MINE: "..m.owners[1])
		m.pret = {}
		m.nick = nil
	end
	m.was_loaded = nil
	print("NOW NIL") --]]
	local master, dist = m.inst:GetNearestPlayer(true)
	if dist and dist < 2.5 and master then --Запоминаем того, кто установил, особым образом.
		m.owners[1] = master.userid
		--m.nick = convertfromutf8(master.name) --Теперь, с поддержкой UTF, это не нужно.
		m.nick = master.name
	end
	--[[
	for _,v in ipairs(pl) do --Чекаем остальных игроков по близости. 
		if v.userid and v.userid~=m.owners[1] and (m.inst:GetDistanceSqToInst(v) <= MONITORING_DISTANCE) then
			m.pret[v.userid] = CAN_SEE --СРАЗУ им даем все права на просмотр.
		end
	end
	--]]
	OnUpdateTrap(m.inst,false)
	--[[
	self.inst:DoTaskInTime(0,function() --hack that prevents damage on deploy
		if not self.owners then
		end
		if not self.userid then
			local master, dist = self.inst:GetNearestPlayer(true)
			if dist and dist < 2 and master then
				self.userid = master.userid
				self.nick = master.name
				--self:SetAlignment("nobody")
			end
		end
		return old_reset(self)
	end) --]]
	--Reset вызывает Stop/Start testing, так что все ок
		return old_reset(self)
	end)
end

local MULT_DAMAGE = false
local MULT_DAMAGE_KOEF = GetModConfigData("animal_mult") or 2

local hack_damage_prefab --через эту переменную сообщаем префаб ловушки, которая сработала

local combat = _G.require "components/combat"
local old_GetAttacked = combat.GetAttacked
function combat:GetAttacked(attacker, damage, weapon,...)
	if hack_damage_prefab then --включена система ребаланса и мы должны знать префаб, который сработал
		if BALANCE_DAMAGE and rebalance_traps[hack_damage_prefab] then
			local opt = rebalance_traps[hack_damage_prefab]
			if MULT_DAMAGE and opt.pvp_damage then
				damage = opt.pvp_damage
			elseif opt.animal_damage and not MULT_DAMAGE then
				damage = opt.animal_damage
			end
		end
		if MULT_DAMAGE then
			if type(damage) == "number" then
				damage = damage * MULT_DAMAGE_KOEF
			else
				print('ERROR: bad damage on trap: '..tostring(hack_damage_prefab))
			end
		end
	end
	return old_GetAttacked(self,attacker, damage, weapon,...)
end

local old_explode = mine.Explode
function mine:Explode(target,...)
	--p("Explode")
	if target and target.userid and self.owners then
		for i,v in ipairs(self.owners) do
			if v == target.userid and v~="" then
				--p("Prevent explode")
				return --нельзя срабатывать на тех, кто знает о ловушке
			end
		end
	end
	--двойной урон по животным
	local res
	hack_damage_prefab = self.inst and self.inst.prefab
	if target then
		if not target:HasTag("player") then
			MULT_DAMAGE = true
			res = old_explode(self,target,...)
			MULT_DAMAGE = false
		else
			res = old_explode(self,target,...)
		end
	end
	hack_damage_prefab = false
	return res
end


local old_StartTesting = mine.StartTesting
function mine:StartTesting(...)
	if self.kt_old_StartTesting then
		self:kt_old_StartTesting(...)
	else
		old_StartTesting(self,...)
	end
	--[[local MineTest = self.testtask.fn
	if MineTest then
		self:StopTesting()
		self.testtask = self.inst:DoPeriodicTask(0.36 + 0.02 * math.random() + 0.02 * math.random(), MineTest, math.random(.9, 1))
	end--]]
	if self.testtask then
		self.testtask.period = 0.36 + 0.02 * math.random()
	end
	--self.inst.inv_value = 0.95
	--self.inst.inv_task = self.inst:DoPeriodicTask(0.5, MineFade,0)
	QueueAnim(self.inst,1)
end



local old_StopTesting = mine.StopTesting
function mine:StopTesting(...)
	QueueAnim(self.inst,2)
	return old_StopTesting(self,...)
end


local old_save = mine.OnSave
function mine:OnSave(...)
	local data = old_save(self,...)
	if self.owners then
		if not data then data={} end --lol
		data.owners = self.owners --владельцы (публично)
		data.pret = self.pret --претенденты (приватные владельцы на сервере, набирают очки)
		data.nick = self.nick
	end
	return data
end

local old_load = mine.OnLoad
function mine:OnLoad(data,...)
	old_load(self,data,...)
	if data and data.owners then
		self.owners = data.owners or {"","","","","",""} --Restore user.
		--self.was_loaded = true
		--print("LOAD MINE: "..self.owners[1])
		self.pret = data.pret or {}
		self.nick = data.nick
		--self:SetAlignment("nobody")
	else
		self.owners = {"","","","","",""} --Restore user.
		--print("FAIL LOAD MINE: "..self.owners[1])
		self.pret = {}
	end
	--[[if self.userid then
		self:SetAlignment("nobody")
	end--]]
end


local function OnPutInInventory(inst)
	local m = inst.components.mine
	if m then
		m.pret = {} --обнуляем всю память, т.к. местоположение ловушки меняется
		m.nick = nil --ловушка становится ничейной!
		m.owners = {"","","","","",""} --Я сказал ничейной!!
	end
	--inst.AnimState:OverrideMultColour(1, 1, 1, 1)
	QueueAnim(inst,4)
end

local function TrapDesc(inst, viewer)
	if viewer and viewer.userid then
		local m = inst.components.mine
		if m and m.issprung==false and m.inactive==false then
			if m.owners then
				if m.owners[1]==viewer.userid then
					return "It's my hidden trap!"
				end
				for _,v in ipairs(m.owners) do
					if v==viewer.userid then
						return "I can see it! Ha-ha!"
					end
				end
			end
			return "Oh my God! Hidden trap!!!"
		end
	end
	return inst.components.inspectable.description
end


local function MakeKillerTrap(prefab,opt)
	AddPrefabPostInit(prefab,function(inst)
		local m = inst.components.mine
		if not m then
			return
		end
		--Support of rude mods.
		if m.StartTesting ~= mine.StartTesting then
			m.kt_old_StartTesting = m.StartTesting
			m.StartTesting = mine.StartTesting
		end
		m:SetAlignment("nobody")
		if inst.components.inventoryitem then --need not
			inst.components.inventoryitem:SetOnPutInInventoryFn(OnPutInInventory)
		end
		if inst.components.inspectable then
			inst.components.inspectable.getspecialdescription = TrapDesc
		end
		if not m.owners then
			m.owners = {"","","","","",""} --6 persons
			--print("INIT MINE: "..m.owners[1])
			m.pret = {} --pretendents
		end
		m.new_data = {"","","","","",""} --sorted copy of owners.
		m.sent = {"","","","","",""} --values sent to clients, must be equal to new_data
		--Rebalance
		if opt then
			if opt.uses then
				if not inst.components.finiteuses then
					inst:AddComponent("finiteuses")
				end
				inst.components.finiteuses:SetMaxUses(opt.uses)
				inst.components.finiteuses:SetUses(opt.uses)
			end
			if opt.pvp_damage then
				inst.damage = opt.pvp_damage
			end
		end
		--OnUpdateTrap(inst)
		inst:DoPeriodicTask(TIMER_TICK+math.random()*0.1,OnUpdateTrap,1)
		inst:AddTag("trap") --он и так должен быть, но на всякий случай. Надо для поиска ловушек.
	end)
end

for k,v in pairs(ALL_TRAPS) do
	MakeKillerTrap(k,rebalance_traps[k])
end



local old_net_say = _G.Networking_Say
_G.Networking_Say = function(guid, userid, name, prefab, message, colour, whisper, ...)
	old_net_say(guid, userid, name, prefab, message, colour, whisper, ...)
	local lower_message=string.lower(message)
	if lower_message == "show traps" then
		--p("New command")
		local commander
		for i,v in ipairs(_G.AllPlayers) do
			if v.userid==userid then
				commander = v
				--p("Got commander")
			end
		end
		if commander then
			--p("Commander = "..tostring(commander))
			local x,y,z = commander.Transform:GetWorldPosition()
			local e
			for i,v in ipairs(_G.AllPlayers) do
				if v~=commander and commander:GetDistanceSqToInst(v) < 8*8 then
					if not e then
						e = _G.TheSim:FindEntities(x,y,z,20,{"trap"})
						--p("Find traps")
					end
					for _,t in ipairs(e) do
						local m = t.components.mine
						if m and m.pret
							and ((m.owners and m.owners[1]==commander.userid) --только если коммандер знает ловушку
								or(m.pret[commander.userid]	and m.pret[commander.userid] >= CAN_SEE)
							)
						then
							OnUpdateTrap(t,false,v) --еще раз "устанавливаем" ловушку (старые знакомые не сбрасываются)
							--print("REREST ",tostring(t))
						end
					end
				end
			end
		end
	end
end



end ---------------------------------end of server part --------------------------------------




local function OnMineDirty(inst)
	inst.anim_num = inst.net_anim_num:value()
	SetNewAnim(inst)
end

local function OnMineDirty_n1(inst)
	inst.n1 = inst.net_n1:value()
	SetNewAnim(inst)
end
local function OnMineDirty_n2(inst)
	inst.n2 = inst.net_n2:value()
	SetNewAnim(inst)
end
local function OnMineDirty_n3(inst)
	inst.n3 = inst.net_n3:value()
	SetNewAnim(inst)
end
local function OnMineDirty_n4(inst)
	inst.n4 = inst.net_n4:value()
	SetNewAnim(inst)
end
local function OnMineDirty_n5(inst)
	inst.n5 = inst.net_n5:value()
	SetNewAnim(inst)
end
local function OnMineDirty_n6(inst)
	inst.n6 = inst.net_n6:value()
	SetNewAnim(inst)
end

for k,v in pairs(ALL_TRAPS) do
	AddPrefabPostInit(k,function(inst)
		inst:AddTag("irreplaceable")
	
		--local minimap = inst.entity:AddMiniMapEntity()
		--minimap:SetIcon("no64.tex")
		if inst.MiniMapEntity then
			inst.MiniMapEntity:SetEnabled(false)
		end


		inst.transp_value = 0.1
		inst.AnimState:OverrideMultColour(0.1,0.1,0.1,0.1) --invisible by default
		inst.anim_num = 0
		inst.n1 = ""
		inst.n2 = ""
		inst.n3 = ""
		inst.n4 = ""
		inst.n5 = ""
		inst.n6 = ""
		inst.net_anim_num = _G.net_ushortint(inst.GUID, "anim_num", "mine_dirty") --создаем функцию-обработчик
		--print("inst.net_anim_num = "..tostring(inst.net_anim_num))
		inst.net_n1 = net_string(inst.GUID,"n1","mine_dirty_n1")
		inst.net_n2 = net_string(inst.GUID,"n2","mine_dirty_n2")
		inst.net_n3 = net_string(inst.GUID,"n3","mine_dirty_n3")
		inst.net_n4	= net_string(inst.GUID,"n4","mine_dirty_n4")
		inst.net_n5 = net_string(inst.GUID,"n5","mine_dirty_n5")
		inst.net_n6 = net_string(inst.GUID,"n6","mine_dirty_n6")
		if not _G.TheWorld.ismastersim then
			inst:ListenForEvent("mine_dirty", OnMineDirty)
			inst:ListenForEvent("mine_dirty_n1", OnMineDirty_n1)
			inst:ListenForEvent("mine_dirty_n2", OnMineDirty_n2)
			inst:ListenForEvent("mine_dirty_n3", OnMineDirty_n3)
			inst:ListenForEvent("mine_dirty_n4", OnMineDirty_n4)
			inst:ListenForEvent("mine_dirty_n5", OnMineDirty_n5)
			inst:ListenForEvent("mine_dirty_n6", OnMineDirty_n6)
			return
		end
		--server side code for traps
	
	end)
end

AddPrefabPostInit("birdtrap",function(inst)
	inst:AddTag("irreplaceable")
end)
